<?php
defined ('_JEXEC') or die('Resitriced Access');

jimport( 'joomla.plugin.plugin' );

class plgSystemSmartseo extends JPlugin
{
        /**
         * Constructor
         *
         * For php4 compatability we must not use the __constructor as a constructor for plugins
         * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
         * This causes problems with cross-referencing necessary for the observer design pattern.
         *
         * @access      protected
         * @param       object  $subject The object to observe
         * @param       array   $config  An array that holds the plugin configuration
         * @since       1.0
         */
        function plgSystemCache( &$subject, $config )
        {
                parent::__construct( $subject, $config );

                // Do some extra initialisation in this constructor if required
        }

		function onAfterRender() {
			$mainframe =& JFactory::getApplication('site'); //instance mainframe
			if (!$mainframe->isAdmin()) { 
			

		//display on frontend only 
			$FullURL =& JFactory::getURI();
			$url = $FullURL->toString();
			$uquery =&JURI::getInstance($url);
			$ExtendedQuery = $uquery->getQuery();
			if (strlen($ExtendedQuery)>0) { $url = $uquery->getPath() ."?" .$uquery->getQuery(); }
			else { $url = $uquery->getPath(); }
			
			
			
		//DB Instance
		$db =& JFactory::getDBO();
		
		//retrive saved seo information for current page.
		 global $mainframe;
		 $lights = 0;
		$query = "SELECT keywords, description, title, url FROM #__easyseo where url='$url'";
		$db->setQuery($query);
		$data = $db->LoadRow();
				if (strlen($data[0])>0) { $keywords = $data[0]; } else { $keywords = ""; }
				if (strlen($data[1])>0) { $description = $data[1]; } else { $description = ""; }
				if (strlen($data[2])>0) { $title = $data[2]; } else { $title = ""; }
				if (strlen($title)>0) { $lights = $lights +1;}
				if ($title == "") { $title = $mainframe->getPageTitle();}
				$title = str_replace('"','&quot;',$title);
				$dburl = $data[3];
				
				//calc amount of green lights
				
				if (strlen($keywords)>0) { $lights = $lights +1;}
				if (strlen($description)>0) { $lights = $lights +1;}
				
				$lightswidth = $lights * 16;
  
			$repl = "
			<div id=\"es_bar_container\">
			<div id=\"es_bar_hidden\">
				<form action=\"" .$url ."\" method=\"POST\" name=\"easyseo_form\">
				<div class=\"es_bar_1\">
						
						<input name=\"seo_title\" type=\"text\" value=\"" .$title ."\" />
				</div>
				<div class=\"es_bar_2\">
					
					<textarea name=\"seo_description\" 
						onKeyDown=\"textCounter(document.easyseo_form.seo_description,document.easyseo_form.remLen1)\"
						onKeyUp=\"textCounter(document.easyseo_form.seo_description,document.easyseo_form.remLen1)\">".$description ."</textarea>
					<input readonly type=\"text\" name=\"remLen1\" id=\"description_count\">
				</div>
				<div class=\"es_bar_3\">
					
					<textarea name=\"seo_keywords\"
						onKeyDown=\"textCounter(document.easyseo_form.seo_keywords,document.easyseo_form.remLen2)\"
						onKeyUp=\"textCounter(document.easyseo_form.seo_keywords,document.easyseo_form.remLen2)\">".$keywords ."</textarea>
					<input readonly type=\"text\" name=\"remLen2\" id=\"keywords_count\">
				</div>
				<input type=\"hidden\" name=\"seo_post\" value=\"1\" />";
				if ($dburl != "") { $repl .= "<input type=\"hidden\" name=\"seo_update\" value=\"1\" />";}
				$repl .= "<input name=\"easyseo_submit\" type=\"submit\" value=\"Apply\" />
				</form>
			</div>
			
				<div id=\"es_bar\" onclick=\"javascript:metaKeywords('keywords');
				javascript:metaDescription('description');
				visibility_smart('es_bar_hidden');
				textCounter(document.easyseo_form.seo_description,document.easyseo_form.remLen1);
				textCounter(document.easyseo_form.seo_keywords,document.easyseo_form.remLen2);
				\">
					<div class=\"es_bar_left\">
						<form id=\"form-login\" name=\"login\" method=\"post\" action=\"".$url ."\">
							<input type=\"submit\" value=\"Log out\" class=\"button\" name=\"Submit\">
							<input type=\"hidden\" value=\"com_user\" name=\"option\">
							<input type=\"hidden\" value=\"logout\" name=\"task\">
						</form>
					</div>
					
						<div class=\"es_bar_right\">
							<div id=\"glights\">
								<div id=\"lights\" style=\"width:$lightswidth" ."px;\"></div>
							</div>
						</div>
					
					<div style=\"clear:both;\"></div>
				</div>
			
			</div>";
			$plugin =&JPluginHelper::getPlugin('system','smartseo');
			$params = new JParameter($plugin->params);
			$user =& JFactory::getUser();
			$userlevel = $user->usertype;
			$SelectedUserlevel = $this->params->get('access_level');
			
			switch ($SelectedUserlevel) {
				case 'Super Administrator':
					if ($userlevel == 'Super Administrator') {
						$body = JResponse::getBody();
						if (strpos($body,"</body>")) {
							$content = str_replace("</body>",$repl ."</body>",$body);
						}
						else {
							$content = str_replace("</html>",$repl ."</body></html>",$body);
						}
						JResponse::setBody($content);
					}
					break;
				case 'Administrator':
					if ($userlevel == 'Administrator' || $userlevel == 'Super Administrator') {
						$body = JResponse::getBody();
						if (strpos($body,"</body>")) {
							$content = str_replace("</body>",$repl ."</body>",$body);
						}
						else {
							$content = str_replace("</html>",$repl ."</body></html>",$body);
						}
						JResponse::setBody($content);
					}
					break;
				case 'Manager':
					if ($userlevel == 'Manager' || $userlevel == 'Administrator' || $userlevel == 'Super Administrator') {
						$body = JResponse::getBody();
						if (strpos($body,"</body>")) {
							$content = str_replace("</body>",$repl ."</body>",$body);
						}
						else {
							$content = str_replace("</html>",$repl ."</body></html>",$body);
						}
						JResponse::setBody($content);
					}
					break;
				case 'Publisher':
					if ($userlevel == 'Publisher' || $userlevel == 'Manager' || $userlevel == 'Administrator' || $userlevel == 'Super Administrator') {
						$body = JResponse::getBody();
						if (strpos($body,"</body>")) {
							$content = str_replace("</body>",$repl ."</body>",$body);
						}
						else {
							$content = str_replace("</html>",$repl ."</body></html>",$body);
						}
						JResponse::setBody($content);
					}
					break;
				}
				
			}
		}
			
		
		
        function onAfterDispatch() {
			$mainframe =& JFactory::getApplication('site'); //instance mainframe
				if (!$mainframe->isAdmin()) { 
			
				//get currect URL
				$FullURL =& JFactory::getURI();
				$url = $FullURL->toString();
				$uquery =&JURI::getInstance($url);
				$ExtendedQuery = $uquery->getQuery();
				if (strlen($ExtendedQuery)>0) { $url = $uquery->getPath() ."?" .$uquery->getQuery(); }
				else { $url = $uquery->getPath(); }
				
				//DB Instance
				$db =& JFactory::getDBO();
				//Submit SEO information if post was made
				$seo_post = JRequest::getVar('seo_post');
				if ($seo_post == 1) {
					$p_seo_title = addslashes(JRequest::getVar('seo_title'));
					$p_seo_keywords = addslashes(JRequest::getVar('seo_keywords'));
					$p_seo_description = addslashes(JRequest::getVar('seo_description'));
					$p_seo_update = JRequest::getVar('seo_update');
					if ($p_seo_update != 1) {
						$query = "INSERT INTO #__easyseo (url,title,keywords,description) VALUES('$url','$p_seo_title','$p_seo_keywords','$p_seo_description')";
					}
					else {
						$query = "UPDATE #__easyseo SET title='$p_seo_title', keywords='$p_seo_keywords', description='$p_seo_description' WHERE url='$url'";
					}
					$db->setQuery($query);
					if (!$db->query()) { echo $db->ErrorMsg() ."<br/>"; } 
				
				}
				
				//Retrive DB Information
				$query = "SELECT keywords, description, title FROM #__easyseo where url='$url'";
				$db->setQuery($query);
				$data = $db->LoadRow();
						$keywords = $data[0];
						$description = $data[1];
						$title = $data[2];
						if ($title == "") { global $mainframe; $title = $mainframe->getPageTitle();}
				//mainframe
				$mainframe =& JFactory::getApplication('site'); //instance mainframe
				if ($keywords != "") { $mainframe->addMetaTag('keywords',$keywords); } //set the Keywords Metatag
				if ($description != "") { $mainframe->addMetaTag('description',$description); } //set the Description Metatag
				$mainframe->setPagetitle($title); //set page title
				
				
				//FRONT END GUI
				$doc =& JFactory::getDocument();
				$user =& JFactory::getUser();
				$userlevel = $user->usertype;
				$SelectedUserlevel = $this->params->get('access_level');

			switch ($SelectedUserlevel) {
				case 'Super Administrator':
					if ($userlevel == 'Super Administrator') {
						$doc->addStyleSheet(JURI::base() ."plugins/system/easyseo/style.css");
						$doc->addScript(JURI::base() ."plugins/system/easyseo/toggleid.js");
					}
					break;
				case 'Administrator':
					if ($userlevel == 'Administrator' || $userlevel == 'Super Administrator') {
						$doc->addStyleSheet(JURI::base() ."plugins/system/easyseo/style.css");
						$doc->addScript(JURI::base() ."plugins/system/easyseo/toggleid.js");
					}
					break;
				case 'Manager':
					if ($userlevel == 'Manager' || $userlevel == 'Administrator' || $userlevel == 'Super Administrator') {
						$doc->addStyleSheet(JURI::base() ."plugins/system/easyseo/style.css");
						$doc->addScript(JURI::base() ."plugins/system/easyseo/toggleid.js");
					}
					break;
				case 'Publisher':
					if ($userlevel == 'Publisher' || $userlevel == 'Manager' || $userlevel == 'Administrator' || $userlevel == 'Super Administrator') {
						$doc->addStyleSheet(JURI::base() ."plugins/system/easyseo/style.css");
						$doc->addScript(JURI::base() ."plugins/system/easyseo/toggleid.js");
					}
					break;
				}
			 } 
		 }
}



?>